import { select } from 'd3';
const topData = ['a', 'b', 'c'];
const newData = [['x1', 'x2'], ['y1', 'y2'], ['z1', 'z2']];

const table = select('#root')

const thead = table.selectAll('.table-header').data([null]);
const theadEnter = thead.enter().append('thead').classed('table-header', true);

const trEnter = theadEnter.append('tr');
const tr = thead.select('tr');

const thInner = trEnter.merge(tr).selectAll('.th-inner').data(topData);
const thInnerEnter = thInner.enter()
	.append('th')
	.append('div')
		.attr('class', 'th-inner')
		.text(d => d);

// Nested Data Join for Each Element in an Array with Different Data from the parent elements
const cells = trEnter.merge(tr)
	.selectAll('div.th-inner').data(newData) // Make a data join on parent elements with new data
	.selectAll('div.th-but').data(d => d); // Nested data join with each entry as the data for each selected parent element

const cellsEnter = cells.enter()
	.append('div')
		.classed('th-but', true)
		
cellsEnter
	.insert('input')
		.attr('type', 'checkbox')
		.attr('value', d => d);

cellsEnter
		.append('span')
		.text(d => d);
		
